<style>

    label {

        width: auto !important;
    }

</style>

<template src="./summary.htm"></template>

<script>

    export default {

        mounted() {

            this.getCart();

            this.billing_info.billing_name   = this.user.name;
            this.billing_info.billing_phone  = this.user.phone;
        },

        data() {

            return {

                user: JSON.parse(this.userData),

                products: [],

                billing_info: {

                    billing_name: '',
                    billing_phone_number: '',
                    billing_address: '',
                    billing_city: '',
                    billing_zip: '',
                    billing_floor: '',
                    billing_flat: '',
                    billing_intercom: '',
                    delivery_company: '',
                    user_comment: ''
                },

                deletingProduct: null,

                loading: false,

                views: {

                    cart: true,

                    addressForm: false,

                    preview: false,
                },

                success: false
            }
        },

        props: ['userData'],

        computed: {

            total() {

                let total = 0;

                this.products.forEach( (el) => {

                    total += el.price * el.quantity;
                });

                return total.toFixed(2);
            }
        },

        methods: {

            getCart() {

                this.loading = true;

                axios.get(route('client.cart.all'))

                    .then((response) => this.products = response.data.data)

                    .catch((errors) => parseResponseErrors(errors.response))

                    .then( () => this.loading = false)
            },

            /**
             * Remove from database.
             *
             * @param id
             */
            removeProduct(id) {

                this.loading = true;

                axios.get(route('client.cart.destroy', id))

                    .then( (response) => {

                        this.removeProductFromArray(id);

                        $("#cartModal").modal('hide');
                    })

                    .catch( (errors) => parseResponseErrors(errors.response))

                    .then( () => this.loading = false)
            },

            setDeletingProduct(id) {

                this.deletingProduct = id;

                $("#cartModal").modal({backdrop: 'static', keyboard: false})
            },


            /**
             * @param src
             * @return {*}
             */
            imageCacheRoute(src) {

                return route('images.cache', { template: 'small', filename: src });
            },


            /**
             * Remove from products array.
             * @param id
             */
            removeProductFromArray(id) {

                for (let i = 0; i < this.products.length; i++) {

                    let obj = this.products[i];

                    if (obj.cart_id == id) {

                        this.products.splice(i, 1);
                    }
                }
            },


            increaseQuantity(index) {

                this.products[index].quantity++;
            },


            decreaseQuantity(index) {

                if (this.products[index].quantity > 1) {

                    this.products[index].quantity--;
                }
            },

            showCart() {

                this.views.cart         = true;
                this.views.addressForm  = false
            },


            showAddressForm() {

                this.loading = true;

                axios.post(route('client.cart.quantity.update'), createRequestObject({ products: this.products.map( (el) => { return { id: el.cart_id, quantity: el.quantity }})}))

                    .then( (response) => this.showAddress())

                    .catch( (errors) => parseResponseErrors(errors.response))

                    .then( () => this.loading = false)
            },

            showAddress() {

                this.views.cart         = false;
                this.views.preview      = false;
                this.views.addressForm  = true
            },

            showPreview(invalid) {

                this.views.cart         = false;
                this.views.addressForm  = false;
                this.views.preview      = true;
            },

            createProductsRequestObject() {

                return this.products.map( (el) => {

                    return {

                        'product_variant_id': el.variant.id,
                        'quantity': el.quantity
                    }
                })
            },

            submitOrder() {

                this.loading = true;

                axios.post(route('client.order.create'), createRequestObject({

                        products: this.createProductsRequestObject(),
                        billing_info: this.billing_info

                    }))

                    .then( (response) => {

                        this.success = true;
                        this.views.preview = false;
                    })

                    .catch( (response) => {})

                    .then( () => this.loading = false)
            }
        }
    }

</script>